'use strict';
const util = require('util');
var mongoose = require('mongoose');

var Schema = mongoose.Schema;

var schemaName = "PostStatus";

var schemaOption = {
    bufferCommands: false,
    collection : 'post_statues'
};

var schema = new Schema({
    name: { type: String, unique : true, required : true},
    id: { type: Number, unique : true, required : true}
}, schemaOption);

//Enable unique validator
schema.plugin(require('mongoose-unique-validator'));

var Model = mongoose.model(schemaName, schema);

Model.Name = schemaName;

Model.createModel = function (dbContext, data){
    var model = dbContext.model(schemaName, schema);
    if(util.isNullOrUndefined(data))
        return model;
    return new model(data);
}

module.exports = Model;