var domain = {};
var defaultNamespace = 'hl'; // _sub_hl_

domain.subDomain = function (options) {
    options = options || {};

    // Support previous `www` boolean option
    var whitelist = options.www === false ? [] : ['www'];

    var path = '/' + (options.namespace || defaultNamespace);

    if (typeof options.whitelist === 'string') {
        whitelist = [options.whitelist];
    } else if (Array.isArray(options.whitelist)) {
        whitelist = options.whitelist;
    }

    return function (req, res, next) {
        var subdomains = req.subdomains;

        var host = req.hostname;

        var inWhitelist = whitelist.some(function(subdomain) {
            var i = subdomains.indexOf(subdomain)
            return i > -1
        })

        if (inWhitelist) return next()

        // var url = req.url;
        // if(!subdomains.length > 0 && (url.indexOf('assets') > -1 || url.indexOf('client') > -1 || url.indexOf('_data') > -1)) next()

        // continue if no subdomains
        if (!subdomains.length) return next()

        //ignore static files: .js, .css, images, document
        if(req.url.indexOf('.') > 0) return next();

        // rebuild url
        //req.url = path + subdomains.join('/') + req.url
        req.url = path + req.url;

        // Q.E.D.
        next()
    }
}

domain.routeSubDomain = function(routeName,  options) {
    options = options || {};

    if (routeName.startsWith('/')) {
        routeName =  '/' + (options.namespace || defaultNamespace) + routeName;
    } else {
        routeName = '/' +  (options.namespace || defaultNamespace) + '/' + routeName;
    }

    return routeName;
}

module.exports = domain;

