'use strict';

const winston = require('winston');
require('winston-mongodb').MongoDB;
var path = require('path');
const util = require('util');
var logDir = path.resolve(__dirname, '../../', 'logs');
var options = {};


var exception = function(logConfig) {
    if(logConfig !== undefined) {
        options = {
            db: 'mongodb://' + logConfig.host + ':' + logConfig.port + '/' + logConfig.db,
            collection: logConfig.collection,
        }
    }
};

exception.prototype.log = function(info) {
    options.level = 'info';
    var transports = [
        new (winston.transports.File)({
            filename: path.join(logDir, 'info.log'),
            level: options.level
        })];
    if(options.db !== undefined){
        transports.push(
            new (winston.transports.MongoDB)(options)
        );
    }
    var logger = new (winston.Logger)({
        transports: transports
    });

    logger.log('info', info);
}

exception.prototype.error = function(ex) {
    //Log error to file or logging system
    options.level = 'error';
    var transports = [
        new (winston.transports.File)({
            filename: path.join(logDir, 'error.log'),
            level: options.level
        })];
    if(options.db !== undefined){
        transports.push(
            new (winston.transports.MongoDB)(options)
        );
    }

    var logger = new (winston.Logger)({
        transports: transports
    });

    console.log("Error occurred", ex);

    logger.log('error', ex);
}

module.exports = exception;