var html = {};

const htmlMetadata = require('html-metadata');

html.getMetadata = function(url){
    return new Promise(function(resolve, reject){
        htmlMetadata(url, function(error, metadata) {
            if (metadata != undefined && metadata.openGraph != undefined) {
                metadata.openGraph.status = true;
                if (metadata.openGraph.image == undefined) {
                    metadata.openGraph.image = { url: (metadata.jsonLd != undefined) ? metadata.jsonLd[0].image.url : '' };
                }
                else {
                    metadata.openGraph.image = { url: (metadata.openGraph.image.length > 0) ? metadata.openGraph.image[0].url : metadata.openGraph.image.url }
                }

                if (metadata.openGraph.title == undefined || metadata.openGraph.title == '') {
                    metadata.openGraph.title = metadata.general.title;
                }

                if (metadata.openGraph.description == undefined || metadata.openGraph.description == '') {
                    metadata.openGraph.description = metadata.general.description;
                }

                resolve(metadata.openGraph);
            }
            else {
                reject(error);
            }
        });
    });
}



module.exports = html;