var location = {};

const requestIp = require('request-ip');
const countries = require ('countries-cities');
const request = require('request');

location.getLocationByIP = function (ip){
    //send and request to API
    //request format: http://api.db-ip.com/v2/<key>/<ip>
    //example: http://api.db-ip.com/v2/675b6321f4fea1c3a746d808a44cae9a15c1414d/202.78.230.234
    var url = "http://api.db-ip.com/v2/675b6321f4fea1c3a746d808a44cae9a15c1414d/"+ip;
     return new Promise(function(resolve, reject) {
        var result = { Error: {} };
        request({
            url: url,
            method: 'GET',
            json: {}
        }, function (error, response, body) {
            if (error) {
                result.Error = error;
                reject(result);
            }
            else {
                var location = {country: "", city: ""};
                if(body.countryCode != 'ZZ' ){
                    var location = {country: body.countryName, city: body.city};
                }
                resolve(location);
            }
        });
    });
}

location.getCountryList = function(){
    return countries.getCountries();
    //use 3rd library to get country list
    //return countries
}

location.getCityListByCountryName = function (countryName){
    return countries.getCities(countryName);
    //use 3rd library to get city list by country name
    //return list of city in that country
}

location.getClientIP = function (req){
    const clientIp = requestIp.getClientIp(req); 
    return clientIp;
}

module.exports = location;