var database = {};
const config = require('../_config');
const util = require('util');
var UserActivity = require('./model/UserActivity');
var ReturnResult = require('../model/ReturnResult');
var mongoose = require('mongoose');

database.connectDb = function (){
    var connectionSetting = config.mongodb.headlight_main;
    var connectionOptions = connectionSetting.options;
    connectionSetting = util.format('mongodb://%s:%s/%s', connectionSetting.host, connectionSetting.port, connectionSetting.db);

    return new Promise(function(resolve, reject){
        var dbContext = mongoose.createConnection(connectionSetting, connectionOptions);

        dbContext.on('connected', function (){
            console.log('MongoDB event connected');
            resolve(dbContext);
        });

        dbContext.on('error', function(err){
            reject(err);
        });
    });
};

//Save user's activity to MongoDB
database.saveUserActivity = function(data){
    //connect
    return new Promise(function(resolve, reject){
        database.connectDb().then(success, error);
        function success(db){
            console.log("track data", data);
            var userActivity = new UserActivity(db, data);
            userActivity.save(function(err) {
                console.log("Error", err);
                if (!util.isNullOrUndefined(err)) {
                    reject(err);
                }
                else
                    resolve(ReturnResult.SUCCESS);
            });
        }

        function error(err){
            reject(err);
        }
    });
}

module.exports = database;