'use strict';
var mongoose = require('mongoose');
var Schema = mongoose.Schema;

var userActivitySchemaOption = {
    bufferCommands: false,
    collection : 'user_activities'
};
var userActivitySchema = new Schema({
    user: {
        userId: { type: String },
        email: { type: String, default: '' },
        photo: { type: String, default: '' },
        fullname: { type: String, default: '' },
        roleName: { type: String, default: '' },
    },
    feature: { type: String, default: '' }, // portfolio or pitch,...
    page: {
        title: {type: String, default: ''},
        url: {type: String, default: ''},
        id: {
            portfolio: {type: String, default: ''},
            profile: {type: Number, default: ''}
        }
    }, // 1: public status; 2: post status
    action: { type: String, default: '' }, // (read or write)
    device: { type: String, default: '' }, // mobile or laptop...
    os: { type: String, default: '' }, // android or ios,...
    browser: { type: String, default: '' }, // chrome or firefox
    ip: { type: String, default: '' }, //...
    city: { type: String, default: '' },
    country: { type: String, default: '' },
    date: { type: String, default: Date.now }
}, userActivitySchemaOption);

module.exports = userActivitySchema;