const chai = require('chai');
const expect = chai.expect;
var database = require('./database');


describe('Database testing', function() {
    this.timeout(15000);
    it('show connect to mongodb', function(done){
        database.connectDb().then(function(db){
            done();
        }, function(err){
            done(err);
        });
    });

    it('save user activity to database', function(done){
        database.connectDb().then(function(db){
            var data = {
                userid: 1,
                feature: 'Portfolio',
                page: 'Add URL',
                action: 'POST',
                device: 'DESKTOP',
                os: 'WINDOWS 10',
                browser: 'Chrome',
                ip: '172.16.0.7',
                city: 'HCM',
                country: 'VN'
            }

            database.saveUserActivity(data).then(function(result) {
                done();
            }, function (err){
                var error = {message: "Save info error", detail: err};
                done(error);
            });
        }, function(err){
            done(err);
        });
    });
});